<?php
/**
* @version		$Id: mod_search_phone.php 10855
* Dieter Menne, modified after search
* @package		Joomla
* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

$errPhone = CheckValidPhoneList($module->id,$params);  
$width			 = intval($params->get('width', 20));
$maxlength		 = $width > 20 ? $width : 20;

$text			 = $params->get('text', JText::_('search...'));
$set_Itemid		 = intval($params->get('set_itemid', 0));
$moduleclass_sfx = $params->get('moduleclass_sfx', '');

require(JModuleHelper::getLayoutPath('mod_search_phone'));


function CheckValidPhoneList($moduleid,$params)
{
  $err = "";
  $lastUpdate = intval($params->get('lastupdate',''));
  // Should use "images' as a variable here
  $dir = 'images/search_phone';
  if (!is_dir($dir)) mkdir($dir);
  $phb = $params->get('phonebookfile');

  $phonebook = JPath::clean($dir .DS. $phb) ;
  $phonebookfile = realpath($phonebook);
  if (!file_exists($phonebookfile))
    return JText::_("Phonebook $phb not found");
  $lastModified = filemtime($phonebookfile);
  if ($lastModified != $lastUpdate){
    $err = ReadPhoneList($phonebookfile,$params->get('category', ''));
    if ($err != '') return $err;
    $err = JText::_("New phonebook was read in");
    // Update last change 
    $row   =& JTable::getInstance('module');
    $row->load( $moduleid );
    $row->params=preg_replace('/(lastupdate=) *\d*/' ,'${1}'.$lastModified, $row->params);
    $row->store();
  }
  return $err;
}

function ReadPhoneList($phonebookfile,$category)
{
  // Get category id
  $db    =& JFactory::getDBO();
  $query = "SELECT id from #__categories where title='$category'";
  $db->setQuery($query);
  $catid = $db->loadResult();
  if ($catid === NULL) 
    return JText::_("<$category> is not a valid category. Please update settings in module search_phone"); 
  $phonebookfile = str_replace("\\","/",$phonebookfile);
  $import=
  "LOAD DATA LOCAL INFILE '{$phonebookfile}'".
  " INTO TABLE #__contact_details".
  " FIELDS TERMINATED BY ';'".
  " LINES TERMINATED BY '\r\n'" .
  " IGNORE 1 LINES" .
  " (@name,@vorname,address,con_position,telephone)" .
  " SET name= CONCAT_WS(' ',@vorname,@name), published=1, catid=$catid";
  $result  = null;
  // Totally remove old
  $trunc = "TRUNCATE TABLE #__contact_details";
  if ($db->Execute($trunc) === FALSE)
    return JText::_("Database error clearing phonebook");
  // Read new
  $result = $db->Execute($import);
  if ($result === FALSE)
    return JText::_("Database error reading phonebook");
  else
    return "";
}